//
//  ViewController.m
//  borajiCam
//
//  Created by matsumoto keiji on 2013/05/23.
//  Copyright (c) 2013年 matsumoto keiji. All rights reserved.
//

#import "ViewController.h"
#import "General.h"
#import "define.h"

@interface ViewController ()

@end

@implementation ViewController

//-------------------------
//画面ロード
//-------------------------
- (void)viewDidLoad
{
    [super viewDidLoad];

	self.isImageNumber = arc4random() % 3 + 1;
	UIImage *borajiImage = [UIImage imageNamed:[NSString stringWithFormat:@"borraji%dB.png",self.isImageNumber]];
	self.o_imageView.image = borajiImage;
	
	UIImage *iconImage = [UIImage imageNamed:[NSString stringWithFormat:@"boraji_icon%d.png",self.isImageNumber]];
	self.o_iconImageView.image = iconImage;
	self.picImage = nil;
	
	if ([[UIScreen mainScreen] bounds].size.height != 568){
		self.o_imageView.frame = [General moveControllRect:self.o_imageView.frame diff:CGRectMake(-32, 0, 0,0)];
	}
}

//-------------------------
//メモリ警告
//-------------------------
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

//-------------------------
//撮影ボタン
//-------------------------
- (IBAction)tapCamera:(id)sender {
    // カメラが利用できるか確認
    if([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
        
        UIImagePickerController *imagePickerController = [[UIImagePickerController alloc] init];
        // カメラかライブラリからの読み込み指定。カメラを指定
        [imagePickerController setSourceType:UIImagePickerControllerSourceTypeCamera];
		
        // トリミングなどを行うか否か
        [imagePickerController setAllowsEditing:NO];
        // Delegateをセット
        [imagePickerController setDelegate:self];
		
		UIImage *borajiImage = [UIImage imageNamed:[NSString stringWithFormat:@"borraji%dc.png",self.isImageNumber]];
		UIImageView *imageView = [[UIImageView alloc]initWithImage:borajiImage];
		
		[imagePickerController.view addSubview:imageView];
        
        // アニメーションをしてカメラUIを起動
        [self presentViewController:imagePickerController animated:YES completion:nil];
    }
}



//-------------------------
//撮影終了デリゲート
//-------------------------
- (void)imagePickerController:(UIImagePickerController*)picker
        didFinishPickingImage:(UIImage*)image
				  editingInfo:(NSDictionary*)editingInfo
{
	DLog(@"didFinishPickingImage");

	// カメラUIを閉じる
    [self dismissViewControllerAnimated:YES completion:nil];
	self.picImage = image;
	[self makeBoraImage:image];
}



//-------------------------
//合成
//-------------------------
- (void)makeBoraImage:(UIImage*)image
{

	//[self presentModalViewController:view animated:YES];

	CGRect imageRect = CGRectMake(0.0f, 0.0f, 640.0f, 480.0f);;
	DLog(@"size:%f %f",image.size.width,image.size.height);
	

	//NSString *imageFilename = [[NSBundle bundleForClass:[self class]] pathForResource:@"borraji1" ofType:@"png"];
	UIImage *borajiImage = [UIImage imageNamed:[NSString stringWithFormat:@"borraji%dB.png",self.isImageNumber]];

	
	//カメラを縦位置にした場合は画像が潰れます。面倒なのでそこらへんの処理は省略。適当に改造してください。
	
	
	// グラフィックスコンテキストを作る
	UIGraphicsBeginImageContext(imageRect.size);
	
	//CGContextRef context = UIGraphicsGetCurrentContext();
	
    // 画像を縮小して描画する
	[image drawInRect:imageRect];
	
	
    // 描画した画像を取得する
	[borajiImage drawInRect:imageRect];
    UIImage *shrinkedImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
		

	self.o_imageView.image = shrinkedImage;

	return;

	
}


//-------------------------
//保存
//-------------------------
- (IBAction)tapSave:(id)sender {
	//イメージを保存
	UIImageWriteToSavedPhotosAlbum(self.o_imageView.image,self,nil,NULL);
	[General showMsg:@"保存しました。"];
}

//-------------------------
//レイヤー切替
//-------------------------
- (IBAction)tapImageLeft:(id)sender {

	self.isImageNumber++;
	if(self.isImageNumber > 3) self.isImageNumber = 1;
	
	UIImage *iconImage = [UIImage imageNamed:[NSString stringWithFormat:@"boraji_icon%d.png",self.isImageNumber]];
	self.o_iconImageView.image = iconImage;

	if(self.picImage) [self makeBoraImage:self.picImage];
	else {
		UIImage *borajiImage = [UIImage imageNamed:[NSString stringWithFormat:@"borraji%dB.png",self.isImageNumber]];
		self.o_imageView.image = borajiImage;
	}
}

//-------------------------
//ツイッターに投稿
//-------------------------
- (IBAction)tapTwitter:(id)sender {
	SLComposeViewController *twitterPostVC = [SLComposeViewController composeViewControllerForServiceType:SLServiceTypeTwitter];
	[twitterPostVC setInitialText:@"ボラカメラから投稿！ "];
	[twitterPostVC addImage:self.o_imageView.image];
	[self presentViewController:twitterPostVC animated:YES completion:nil];
	
}

//-------------------------
//Facebookに投稿
//-------------------------
- (IBAction)tapFacebook:(id)sender {
	SLComposeViewController *facebookPostVC = [SLComposeViewController composeViewControllerForServiceType:SLServiceTypeFacebook];
	[facebookPostVC setInitialText:@"ボラカメラから投稿！ "];
	[facebookPostVC addImage:self.o_imageView.image];
	[self presentViewController:facebookPostVC animated:YES completion:nil];
}
@end
